$main::pluginvariable{'presencepause'}{'enabled'}{'enabled'} = 1;

my $presencepausechannel = defined($main::pluginconfig{'presencepause'}{'queue_member_channel'}{''})?$main::pluginconfig{'presencepause'}{'queue_member_channel'}{''}:'SIP/#{EXTEN}';

$Client_Pre_Command_Handler{'presencepause'}{'setastdb'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my ($key,$exten,$data) = split(/~/,$destino);

    if ( !main::hasPermChannel( $socket, "queueagent", $mychannel ) && !main::hasPerm( $socket, "queuemanager" ) && !main::hasPerm( $socket, "all" ) && !main::hasPerm( $socket, "queuepause" )) {
        # No permission, abort action
        print "No permissions for pause\n";
        return @allreturn;
    }

    if($key eq "fop2state") {
        if ( $data =~ m/^([A-Za-z0-9+\/]{4})*([A-Za-z0-9+\/]{4}|[A-Za-z0-9+\/]{3}=|[A-Za-z0-9+\/]{2}==)$/ ) {
            $data = FOP2::utils::decode_base64($data);
        }

        my $finalchannel = $presencepausechannel;
        $finalchannel =~ s/#\{EXTEN\}/$exten/g;
        my @canalitos = split(/&/,$finalchannel);

        if($data ne "") {

            my $epoch = time();
            $return  = "Action: DBPut\r\n";
            $return .= "Family: PAUSECUSTOM\r\n";
            $return .= "Key: AGENT/$exten\r\n";
            $return .= "Val: $data:$epoch\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            for my $canali (@canalitos) {

                print "pongo pausa a canal $canali intentnado header PausedReason\n";

                $return  = "Action: QueuePause\r\n";
                $return .= "Interface: $canali\r\n";
                $return .= "Paused: 0\r\n";
                $return .= "\r\n";
                push @allreturn, $return;
 
                $return  = "Action: QueuePause\r\n";
                $return .= "Interface: $canali\r\n";
                $return .= "Paused: 1\r\n";
                $return .= "Reason: $data\r\n";
                $return .= "PausedReason: $data\r\n";
                $return .= "\r\n";
                push @allreturn, $return;
            }

        } else {
            $return  = "Action: DBDel\r\n";
            $return .= "Family: PAUSECUSTOM\r\n";
            $return .= "Key: AGENT/$exten\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            for my $canali (@canalitos) {
                $return  = "Action: QueuePause\r\n";
                $return .= "Interface: $canali\r\n";
                $return .= "Paused: 0\r\n";
                $return .= "\r\n";
                push @allreturn, $return;
            }
       }
    }
    return @allreturn;
};

$AMI_Event_Handler{'presencepause'}{'QUEUEMEMBERPAUSED'} = sub {
    # Just a demo/placeholder

    my $event = shift;
    #my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";

    my @allreturn = ();
    my $locallocation = ${$event}{Location};  # same as Interface on newer asterisk
    my $reason        = ${$event}{Reason};
    if(defined(${$event}{PausedReason})) {
        $reason        = ${$event}{PausedReason};
    } 

    my $tech = "SIP";
    my $finalchannel = $presencepausechannel;
    my @canalitos = split(/&/,$finalchannel);
    for my $canali (@canalitos) {
        if($canali =~ m/PJSIP/i) {
            $tech = "PJSIP"; 
        }
    }

    print "QUEUEMEMBERPAUSED reason ($reason)\n";

    if ( $locallocation =~ m/^(Local|SIP|PJSIP)\/([^\@-]*)\@?([^\/]*)?(\/n)?/i ) {
            my $ext = $2;

            if(${$event}{Paused}==1) {
                if($reason ne "") {
                    my $epoch = time();
                    $return  = "Action: DBPut\r\n";
                    $return .= "Family: PAUSECUSTOM\r\n";
                    $return .= "Key: AGENT/$ext\r\n";
                    $return .= "Val: $reason:$epoch\r\n";
                    $return .= "\r\n";
                    push @allreturn, $return;

                    $return  = "Action: DBPut\r\n";
                    $return .= "Family: fop2state\r\n";
                    $return .= "Key: USER/$ext\r\n";
                    $return .= "Val: $reason\r\n";
                    $return .= "\r\n";
                    push @allreturn, $return;
 
                    $return = "Action: UserEvent\r\n";
                    $return .= "UserEvent: FOP2ASTDB\r\n";
                    $return .= "Family: fop2state\r\n";
                    $return .= "Key: $ext\r\n";
                    $return .= "Channel: USER/$ext\r\n";
                    $return .= "Value: $reason\r\n";
                    $return .= "\r\n";
                    push @allreturn, $return;

                    $return  = "Action: DBPut\r\n";
                    $return .= "Family: fop2state\r\n";
                    $return .= "Key: $tech/$ext\r\n";
                    $return .= "Val: $reason\r\n";
                    $return .= "\r\n";
                    push @allreturn, $return;
 
                    $return = "Action: UserEvent\r\n";
                    $return .= "UserEvent: FOP2ASTDB\r\n";
                    $return .= "Family: fop2state\r\n";
                    $return .= "Key: $ext\r\n";
                    $return .= "Channel: $tech/$ext\r\n";
                    $return .= "Value: $reason\r\n";
                    $return .= "\r\n";

                    push @allreturn, $return;
                }

            } else {
                $return  = "Action: DBDel\r\n";
                $return .= "Family: PAUSECUSTOM\r\n";
                $return .= "Key: AGENT/$ext\r\n";
                $return .= "\r\n";
                push @allreturn, $return;

                $return  = "Action: DBDel\r\n";
                $return .= "Family: fop2state\r\n";
                $return .= "Key: USER/$ext\r\n";
                $return .= "\r\n";
                push @allreturn, $return;

                $return = "Action: UserEvent\r\n";
                $return .= "UserEvent: FOP2ASTDB\r\n";
                $return .= "Family: fop2state\r\n";
                $return .= "Key: $ext\r\n";
                $return .= "Channel: USER/$ext\r\n";
                $return .= "Value: \r\n";
                $return .= "\r\n";
                push @allreturn, $return;

                $return  = "Action: DBDel\r\n";
                $return .= "Family: fop2state\r\n";
                $return .= "Key: $tech/$ext\r\n";
                $return .= "\r\n";
                push @allreturn, $return;

                $return = "Action: UserEvent\r\n";
                $return .= "UserEvent: FOP2ASTDB\r\n";
                $return .= "Family: fop2state\r\n";
                $return .= "Key: $ext\r\n";
                $return .= "Channel: $tech/$ext\r\n";
                $return .= "Value: \r\n";
                $return .= "\r\n";
                push @allreturn, $return;



            }

     return @allreturn;

     }

};

$AMI_Event_Handler{'presencepause'}{'QUEUEMEMBERREMOVED'} = sub {

    my $event = shift;
    my @allreturn = ();
    my $locallocation = ${$event}{Location};
    my $queue  = ${$event}{Queue};

    my $tech = "SIP";
    my $finalchannel = $presencepausechannel;
    my @canalitos = split(/&/,$finalchannel);
    for my $canali (@canalitos) {
        if($canali =~ m/PJSIP/i) {
            $tech = "PJSIP"; 
        }
    }

    if ( $locallocation =~ m/^(Local|SIP|PJSIP)\/([^\@-]*)\@?([^\/]*)?(\/n)?/i ) {

        # Check to see if its still a queue member from some other queue, if it is
        # Then skip triggering unpause events for presence as it might still be paused
        # on the other queues

        if(defined(&main::isMemberOf)) {
            my @queues = main::isMemberOf($locallocation);
            my $queuecount = 0;
            foreach my $queueismember ( @queues ) {
                if($queueismember !~ m/^QUEUE\/$queue\^/) {
                    $queuecount++;
                } else {
                    # Do not count the same queue as it is being removed just now
                }
            }
            if($queuecount>0) { 
                # It is still a queue membrer, do not send unpause events and just return;
                return @allreturn; 
            }
        }

        # It is not a queue member any more, do unpause

        my $ext = $2;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: PAUSECUSTOM\r\n";
        $return .= "Key: AGENT/$ext\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: fop2state\r\n";
        $return .= "Key: USER/$ext\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return = "Action: UserEvent\r\n";
        $return .= "UserEvent: FOP2ASTDB\r\n";
        $return .= "Family: fop2state\r\n";
        $return .= "Key: $ext\r\n";
        $return .= "Channel: USER/$ext\r\n";
        $return .= "Value: \r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: fop2state\r\n";
        $return .= "Key: $tech/$ext\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return = "Action: UserEvent\r\n";
        $return .= "UserEvent: FOP2ASTDB\r\n";
        $return .= "Family: fop2state\r\n";
        $return .= "Key: $ext\r\n";
        $return .= "Channel: $tech/$ext\r\n";
        $return .= "Value: \r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return = "Action: UserEvent\r\n";
        $return .= "UserEvent: FOP2ASTDB\r\n";
        $return .= "Family: fop2state\r\n";
        $return .= "Key: $ext\r\n";
        $return .= "Channel: $tech/$ext\r\n";
        $return .= "Value: \r\n";
        $return .= "\r\n";
        push @allreturn, $return;

     }
     return @allreturn;
};
